SystemOrganization addCategory: #'IRDA2013-sorting2-Tests'!

TestCase subclass: #S2BubbleSortTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2BubbleSortTests methodsFor: 'as yet unclassified' stamp: 'db 5/13/2013 17:58:33.486'!
testStepwiseSorting
	| list sorter newList |
	"list to sort"
	list := #(3 2 4 1) asOrderedCollection.
	"initializing bubble sorter"
	sorter := S2BubbleSorter new.
	sorter model: list.
	
	self assert: sorter isSorted not.	
		
	newList := sorter nextStep.
	self assert: newList equals: #(2 3 4 1) asOrderedCollection.
	self assert: sorter isSorted not.	
	
	newList := sorter nextStep.
	self assert: newList equals: #(2 3 4 1) asOrderedCollection.
	
	newList := sorter nextStep.
	self assert: newList equals: #(2 3 1 4) asOrderedCollection.
	
	newList := sorter nextStep.
	self assert: newList equals: #(2 3 1 4) asOrderedCollection.
	
	newList := sorter nextStep.
	self assert: newList equals: #(2 1 3 4) asOrderedCollection.
	
	newList := sorter nextStep.
	self assert: newList equals: #(2 1 3 4) asOrderedCollection.
	
	newList := sorter nextStep.
	self assert: newList equals: #(1 2 3 4) asOrderedCollection.
	self assert: sorter isSorted.
	
! !

TestCase subclass: #S2ListTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 15:54:45.008'!
insertPivotAt1
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	list pivot: 7.
	expected := #(3 7 1 2 0 8 0 2) asOrderedCollection.
	list insertPivotAt: 3.
	self assert: (list elements) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 15:55:09.586'!
insertPivotAt2
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	list pivot: 8.
	expected := #(2 3 7 2 0 8 0 1) asOrderedCollection.
	list insertPivotAt: 1.
	self assert: (list elements) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 15:57:59.3'!
testAddElementAsSorted
	| expected list |
	list := S2List new.
	list sortedIndices: #(3 2) asSortedCollection.
	expected := #(4 3 2) asSortedCollection.
	list addIndexAsSorted: 4.
	self assert: (list sortedIndices) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 15:52:43.334'!
testSwitchElments
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	expected := #(3 7 8 0 2 0 1 2) asOrderedCollection.
	list switchElementAt: 3 withElementAt: 5.
	self assert: (list elements) equals: expected.! !

TestCase subclass: #S2QuicksortFocusedIndicesEvaluatorTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2QuicksortFocusedIndicesEvaluatorTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 13:17:01.145'!
testCompareElements1
|evaluator|
	evaluator := S2QuicksortFocusedIndicesEvaluator new.
	self assert: (evaluator compareElementsWithLeft: 4 withRight: 2 withPivot: 3)
	! !

!S2QuicksortFocusedIndicesEvaluatorTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 13:31:41.34'!
testCompareElements2
|evaluator|
	evaluator := S2QuicksortFocusedIndicesEvaluator new.
	self assert: (evaluator compareElementsWithLeft: 1 withRight: 2 withPivot: 3) not
	! !

!S2QuicksortFocusedIndicesEvaluatorTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 13:31:50.005'!
testCompareElements3
|evaluator|
	evaluator := S2QuicksortFocusedIndicesEvaluator new.
	self assert: (evaluator compareElementsWithLeft: 4 withRight: 5 withPivot: 3) not
	! !

TestCase subclass: #S2QuicksortFocusedIndicesFinderTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2QuicksortFocusedIndicesFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 14:07:27.032'!
testNextFocus1
|focus elements finder expected|
	finder := S2QuicksortFocusedIndicesFinder new.
	elements := #(2 5 0 4 1 6 3) asOrderedCollection.
	focus := #(1 6 7) asOrderedCollection.
	expected := #(2 6 7) asOrderedCollection.
	finder nextFocusedElementsIndicesWithCurrentFocus: focus inList: elements.
	self assert: focus equals: expected.
	! !

!S2QuicksortFocusedIndicesFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 14:08:10.81'!
testNextFocus2
|focus elements finder expected|
	finder := S2QuicksortFocusedIndicesFinder new.
	elements := #(2 5 0 4 1 6 3) asOrderedCollection.
	focus := #(2 6 7) asOrderedCollection.
	expected := #(2 5 7) asOrderedCollection.
	finder nextFocusedElementsIndicesWithCurrentFocus: focus inList: elements.
	self assert: focus equals: expected.
	! !

!S2QuicksortFocusedIndicesFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 14:13:57.311'!
testNextFocus3
|focus elements finder expected|
	finder := S2QuicksortFocusedIndicesFinder new.
	elements := #(2 5 0 4 1 6 3) asOrderedCollection.
	focus := #(2 5 7) asOrderedCollection.
	expected := #(2 5 7) asOrderedCollection.
	finder nextFocusedElementsIndicesWithCurrentFocus: focus inList: elements.
	self assert: focus equals: expected.
	! !

!S2QuicksortFocusedIndicesFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 13:44:23.122'!
testNextFocusScattered1
|focus elements finder|
	finder := S2QuicksortFocusedIndicesFinder new.
	elements := #(2 5 0 4 1 6 3) asOrderedCollection.
	focus := #(1 6 7) asOrderedCollection.
	self assert: (finder nextLeftFocusWithCurrentFocus: focus inList: elements) equals: 2.
	self assert: (finder nextRightFocusWithCurrentFocus: focus inList: elements) equals: 5.
	self assert: (finder nextPivotWithCurrentFocus: focus inList: elements) equals: 7.
	! !

!S2QuicksortFocusedIndicesFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 13:44:32.091'!
testNextFocusScattered2
|focus elements finder|
	finder := S2QuicksortFocusedIndicesFinder new.
	elements := #(2 5 0 4 1 6 3) asOrderedCollection.
	focus := #(2 5 7) asOrderedCollection.
	self assert: (finder nextLeftFocusWithCurrentFocus: focus inList: elements) equals: 2.
	self assert: (finder nextRightFocusWithCurrentFocus: focus inList: elements) equals: 5.
	self assert: (finder nextPivotWithCurrentFocus: focus inList: elements) equals: 7.
	! !

TestCase subclass: #S2QuicksortListPartFinderTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2QuicksortListPartFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 11:03:06.365'!
testFindLeftIndex1
	|finder right|
	finder := S2QuicksortListPartFinder new.
	right := finder findLeftIndexInListWithLength: 5 
		withSortedIndices: #(3).
	self assert: right equals: 1.! !

!S2QuicksortListPartFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 11:03:47.957'!
testFindLeftIndex2
	|finder right|
	finder := S2QuicksortListPartFinder new.
	right := finder findLeftIndexInListWithLength: 5 
		withSortedIndices: #(1 2 3 4 5).
	self assert: right equals: nil.! !

!S2QuicksortListPartFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 11:03:40.36'!
testFindLeftIndex3
	|finder right|
	finder := S2QuicksortListPartFinder new.
	right := finder findLeftIndexInListWithLength: 5 
		withSortedIndices: #(2 3 4 5).
	self assert: right equals: 1.! !

!S2QuicksortListPartFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 11:04:02.439'!
testFindLeftIndex4
	|finder right|
	finder := S2QuicksortListPartFinder new.
	right := finder findLeftIndexInListWithLength: 5 
		withSortedIndices: #(1 2 4 5).
	self assert: right equals: 3.! !

!S2QuicksortListPartFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 11:51:41.563'!
testFindRightIndex1
	|finder right|
	finder := S2QuicksortListPartFinder new.
	right := finder findRightIndexInListWithLength: 5 
		withSortedIndices: #(3).
	self assert: right equals: 2! !

!S2QuicksortListPartFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 11:51:45.703'!
testFindRightIndex2
	|finder right|
	finder := S2QuicksortListPartFinder new.
	right := finder findRightIndexInListWithLength: 5 
		withSortedIndices: #(1 2 3 4 5).
	self assert: right equals: nil! !

!S2QuicksortListPartFinderTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 11:51:50.124'!
testFindRightIndex3
	|finder right|
	finder := S2QuicksortListPartFinder new.
	right := finder findRightIndexInListWithLength: 5 
		withSortedIndices: #(1 2 3 4).
	self assert: right equals: 5! !

TestCase subclass: #S2QuicksortListPartSorterTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2QuicksortListPartSorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 15:03:18.251'!
testInitializeFocusedIndices
|partSorter|
	partSorter := S2QuicksortListPartSorter new.	
	partSorter initializeFocusedIndices: #(nil nil nil) withLeftBound: 3 withRightBound: 8! !

TestCase subclass: #S2QuicksorterTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2QuicksorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 14:57:44.895'!
testSort
|sorter sortedList|
	sorter := S2Quicksorter new.
	sorter setupList: #(2 5 8 2 6 4 8 2) asOrderedCollection.
	sortedList := #(2 2 2 4 5 6 8 8) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !
